=== debian/changelog ===
nmodl (0.6-3) unstable; urgency=medium

  * Team Upload.
  * Use canonical name for team
  * Use dh-sequence-python3

 -- Alexandre Detiste <tchet@debian.org>  Sat, 02 Aug 2025 15:55:48 +0200

nmodl (0.6-2) unstable; urgency=medium

  * Team Upload.
  * Drop d/p/05_src-config-config.cpp.in-Drop-build-path-from-NRNUNI.patch
    + Causes the package to FTBFS

 -- Nilesh Patra <nilesh@debian.org>  Sat, 27 Jan 2024 22:59:00 +0530

nmodl (0.6-1) unstable; urgency=medium

  * Team Upload.
  * New upstream version 0.6
  * Backport upstream patch and add few more changes to fixup
    catchv2_3 compatibility (Closes: #1054683)
  * Enable Build-Time tests
  * Add d/salsa-ci.yml
  * Add patch to fix FTBFS with 32 bit archs
  * Do not run tests in parallel to help prevent race condition based failures
  * Add patch to make build reproducible
    + Thanks to Vagrant Cascadian for the patch (Closes: #1034327)
  * Add d/clean to clean off __pycache__ (Closes: #1047577)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 27 Jan 2024 20:54:26 +0530
