=== debian/control ===
Source: nmodl
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: bison,
               bluebrain-hpc-coding-conventions,
               catch2,
               chrpath,
               cmake,
               debhelper-compat (= 13),
               dh-sequence-python3,
               flex,
               libcli11-dev,
               libeigen3-dev,
               libfl-dev,
               libfmt-dev,
               libpython3-dev,
               libspdlog-dev,
               nlohmann-json3-dev,
               pybind11-dev,
               python3-jinja2,
               python3-pkg-resources,
               python3-pytest,
               python3-sympy,
               python3-yaml,
               python3:any
Standards-Version: 4.7.2
Rules-Requires-Root: no
X-Python3-Version: >= 3.11
Homepage: https://github.com/BlueBrain/nmodl
Vcs-Git: https://salsa.debian.org/science-team/nmodl.git
Vcs-Browser: https://salsa.debian.org/science-team/nmodl

Package: nmodl
Architecture: any
Depends: python3-nmodl (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Code generation engine for the NEURON modeling language
 The NMODL Framework is a code generation engine for the
 NEURON MODeling Language (NMODL).
 It is designed with modern compiler and code generation techniques to:
   * Provide modular tools for parsing, analysing and transforming NMODL
   * Provide easy to use, high level Python API
   * Generate optimised code for modern compute architectures
     including CPUs, GPUs
   * Flexibility to implement new simulator backends
   * Support the full NMODL specification

Package: python3-nmodl
Architecture: any
Section: python
Depends: python3-jinja2,
         python3-pkg-resources,
         python3-sympy,
         python3-yaml,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: nmodl
Description: Python support for the NEURON modeling language engine
 The NMODL Framework is a code generation engine for the
 NEURON MODeling Language (NMODL).
 .
 This package contains support for using nmodl from Python.
