=== debian/tests/control ===
Tests: simple
Depends: build-essential,
         python3-nmodl
Restrictions: superficial
