=== debian/watch ===
version=4

https://github.com/BlueBrain/nmodl/tags .*/@ANY_VERSION@\.tar\.gz
